# DECA Architecture

## Abstract

The project development will be done modularly and will be splitted into 
multiple subprojects which require the proper research and development.The
Goal is to develop all the architecture require for the [DECA Protocol](https://docs.google.com/presentation/d/1H4V5X0X-9jnulwmmQBKk7PiStqKoPh_t_h7F0R3kLw0/edit#slide=id.p)

## Project Overview

### General Development
> Note1: Testing should be developed for each smart contract
> Note2: Each Module requires its technical specification and references.

- [ ] [Module 1: Decentralized infrastructure](#module-1:-decentralized-infrastructure) 
- [ ] [Module 2: R&D Decentralizable Architecture](#module-2:-r&d-decentralizable-architecture) 
- [ ] [Module 3: Decentralized Carbon Credits Backlog 2.0](#module-3:-Decentralized-carbon-credits-backlog-2.0)
- [ ] Module 4: ERC1155 or ERC404 Development and testing (cctokens, DECA2, SBT)
- [ ] Module 5: R&D DECA DAO (Vaults, ranking/quadratic voting, whitelist, etc)
- [ ] Module 6: R&D Upgradeable Tokenomics Ultrasound Model (Research and Dev)
- [ ] Module 7: R&D Liquidity Pools DEFI Connector
- [ ] Module 8: R&D Lending DEFI Connector
- [ ] Module 9: Security and Testing
- [ ] Module 10: Rebranding and Technical Marketing.


### Future R&D

* Use Cases List (Awesome DECA).
* Payto DAO (SmartWallet)
* Bounty Program
* Zero Knowledge Proof Carbon Offset (Privacy and Fungibility).

## Modules Description

### Module 1: Decentralized infrastructure

This module its al related to the DECA Decentralized infrastructure model, from 
physical to session layer how to accomplish an easy to deploy and support the 
decentralization of the project by using technologies such as IPFS (Gateways, 
nodes and cluster), docker/incus images, alternative networks such as tor, i2p 
and using blockchain contract to ensure security of nodes listing.

[Module 1 Specification](./module1/module1.md)

### Module 2: R&D Decentralizable Architecture

This module is the presentation and aplication layers it comprise the whole 
development toolset and technologies that DECA will use for its dapps 
development (CI/CD, Helia, OrbitDB, Ethers, frameworks, and others) the goal is
to have a decentralizable base architecture.

[Module 2 Specification](./module2/module2.md)

#### Module 2 alternative WASM and Rust Research

[Module 2 alt. WASM+RUST](./module2/module2-rust.md)


### Module 3 Decentralized Carbon Credits Backlog 2.0

Module 3 is an upgrade of the Decentralized Carbon Credits Backlog, 
by using ipfs helia, orbitdb, ethers and a smart contract to verify carbon
credits approved/verified by the DAO. 

[Module 3 Specification](./module3/module3.md)

### Module 4: ERC1155 or ERC404 Development and testing (cctokens, DECA2, SBT)

### Module 5: R&D DECA DAO (Vaults, ranking/quadratic voting, whitelist, etc)

### Module 6: R&D Upgradeable Tokenomics Ultrasound Model (Research and Dev)

### Module 7: R&D Liquidity Pools DEFI Connector

### Module 8: R&D Lending DEFI Connector

### Module 9: Security and Testing

### Module 10: Rebranding and Technical Marketing.

Module 10 handles websites, user tools, and social networks management with 
automated technical marketing as RSS push events from website blog, articles 
and git commits. Community building is the most important goal of this module 
and weekly calls, education and brainstorming will be the DECA approach to 
creating a stronger, and better-informed community.

> Note: The modules will not be organized in a sequential order necesarily but 
the design should consider the other implementations based on the General 
Diagrams and Use Cases Examples.

[Module 10 Specification](./module10/module10.md)

## General Diagrams and Use Cases

## [LICENSE](./LICENSE.md)

```
Copyright (C) 2024  DECENTRALIZED CLIMATE FOUNDATION A.C.
Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.3
or any later version published by the Free Software Foundation;
with no Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts.
A copy of the license is included in the section entitled "GNU
Free Documentation License".  
```

## References

